<template lang="pug">
mixin ctrlButton()
  button.btn.btn-sm.btn-outline-dark.mx-1&attributes(attributes)
    block

.x-ssvg-item.flex-column.d-flex.justify-content-center.align-items-center
  .x-toolbar.py-2.px-1.w-100.d-flex(v-visible='svg')
    BaseDialog(ref='releaseDialog' title='Reset editor')
      p This will reset the SSVG Editor
      p Do you want to proceed ?
    +ctrlButton()(@click="doRelease" title='clear')
      .fa.fa-trash
    .dropdown
      +ctrlButton.dropdown-toggle(type="button" title='save' data-toggle='dropdown' aria-haspopup='true'  aria-expanded='false')#save-dropdown
        .fa.fa-save
      .dropdown-menu(aria-labelledby='save-dropdown')
        .dropdown-item.b-clickable(@click='saveClipboard()')
          .fa.fa-clipboard.mr-1
          | Copy to clipboard
        .dropdown-item.b-clickable(@click='saveFile()')
          .fa.fa-download.mr-1
          | Save to file
    +ctrlButton()(v-if="hasSession" @click="saveSession()" title='save session')
      .fa.fa-share-square
    span.ml-auto
    BaseAnimationBlock
      button.btn.btn-sm.btn-outline-dark(v-if='isZoom' @click='resetZoom()' title='Reset Zoom')
        .fa.fa-expand-arrows-alt
    .btn-group.mx-1
      button.btn.btn-sm.btn-outline-dark(@click='$options.History.undo()' title='Undo' :disabled='!canUndo')
        .fa.fa-undo
      button.btn.btn-sm.btn-outline-dark(@click='$options.History.redo()' title='Redo' :disabled='!canRedo')
        .fa.fa-redo
    +ctrlButton()(@click="doRefresh" title='refresh')
      .fa.fa-sync
    +ctrlButton()(@click="doToggleViewMode" :title="`viewMode: ${viewMode}`")
      .fa.fa-play(v-if='viewMode === $options.ViewMode.normal')
      .fa.fa-forward(v-if='viewMode === $options.ViewMode.shadow')
      .fa.fa-step-forward(v-if='viewMode === $options.ViewMode.jump')
  .x-canvas.w-100.h-100.position-relative(v-show='svg')
    iframe.x-svg.x-svg-shadow.border-0.w-100.h-100(ref='svgShadow' :class='"x-" + viewMode'
      @load='onDirectSvgFrameLoaded()')
    iframe.x-svg.x-svg-main.border-0.w-100.h-100(ref='svg' :class='"x-" + viewMode'
      @load='onSvgFrameLoaded()')
  .x-canvas.w-100.h-100.d-flex.justify-content-center.align-items-center(v-if='!svg')
    FileDropZone(@file-drop='onFileDrop' @text-drop='onTextDrop')
</template>
<script>

export { default } from "./SSVGItem.vue.js";

</script>
<style lang='scss'>
.x-ssvg-item {
  height: 100%;
  width: 100%;

  .btn-group {
    .btn-outline-dark:not(:last-child) {
      border-right-color: transparent;
    }
    .btn-outline-dark:not(:first-child) {
      border-left-color: transparent;
    }
  }

  .x-canvas {
    box-shadow:
      inset 0rem 1.5rem .5rem -1rem rgba(0, 0, 0, 0.175),
      inset 1.5rem 0rem .5rem -1rem rgba(0, 0, 0, 0.175),
      inset -1.5rem 0rem .5rem -1rem rgba(0, 0, 0, 0.175),
      inset 0rem -1.5rem .5rem -1rem rgba(0, 0, 0, 0.175) !important;
  }

  .x-svg-shadow {
    &.x-shadow {
      opacity: 0.5;
      display: block;
      position: absolute;
      top: 0;
    }
    &.x-jump {
      display: block;
    }
    &.x-normal {
      display: none;
    }
  }

  .x-svg-main {
    &.x-shadow {
      display: block;
    }
    &.x-jump {
      display: none;
    }
    &.x-normal {
      display: block;
    }
  }

  .no-event {
    pointer-events: none;
  }

  .x-icon {
    font-size: 9em;

    &.fa-upload {
      color: lighten(black, 80%);
    }
  }
}
</style>
